import sys,pygame,os,math,random
from pygame.locals import *

blocks = [ [(0,0),(0,-1),(0,1),(0,2)], #I
           [(0,0),(-1,0),(1,0),(0,-1)], #T
           [(0,0),(1,0),(1,1),(0,1)], #box
           [(0,0),(1,0),(0,-1),(1,1)], #S
           [(0,0),(-1,1),(-1,0),(0,-1)], #Z
           [(0,0),(0,1),(0,-1),(1,-1)], #J
           [(0,0),(0,1),(0,-1),(-1,-1)] ] #L

class Block:
    def __init__(self, data, x, y):
        self.structure = data
        self.x = x
        self.y = y

    def rotate(self):
        self.structure = [ (-b,a) for a,b in self.structure ]

    def grid_cor(self):
        return [ (a+self.x/10,b+self.y/10) for a,b in self.structure ]

    def down(self):
        self.y += 10

    def left(self):
        self.x -= 10

    def right(self):
        self.x += 10

    def set_grid_x(self, x):
        self.x = x*10

    def set_grid_y(self, y):
        self.y = y*10

    def draw(self, screen):
        for a,b in self.structure:
            screen.fill((255,0,0), pygame.Rect(10*a+self.x,10*b+self.y,10,10))

def generate_block(start_x, start_y, selector=-1):
    if selector == -1:
        return Block(blocks[int(random.random()*7)], start_x, start_y)
    else:
        return Block(blocks[selector], start_x, start_y)

